/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.map.DuplicateHelper
 *  fire.pb.map.Transfer
 *  fire.pb.mission.fairyland.FairylandMgr
 *  fire.pb.scene.DynamicTemplate
 *  fire.pb.scene.SceneManager
 *  fire.pb.util.CGPlayUtil
 *  mkdb.Procedure
 *  mkdb.Transaction
 *  xbean.Pod
 *  xbean.ShowingMission
 *  xtable.Showingmission
 */
package fire.pb.mission;

import fire.pb.map.DuplicateHelper;
import fire.pb.map.Transfer;
import fire.pb.mission.SMissionData;
import fire.pb.mission.SSpecialScenarioQuestConfig;
import fire.pb.mission.UtilHelper;
import fire.pb.mission.fairyland.FairylandMgr;
import fire.pb.scene.DynamicTemplate;
import fire.pb.scene.SceneManager;
import fire.pb.util.CGPlayUtil;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import mkdb.Procedure;
import mkdb.Transaction;
import xbean.Pod;
import xbean.ShowingMission;
import xtable.Showingmission;

public class MissionConfig {
    public final int missionId;
    public final String missionName;
    public final String missionTypeString;
    public final LimitInfo limitInfo;
    public final ExeInfo exeIndo;
    public final RewardInfo rewardInfo;
    public final AnswerInfo answerInfo;
    public final MissionTaskInfo taskInfo = null;
    public final ScenarioInfo scenarioInfo;
    public final AIInfo aiInfo;
    public final BattleInfo battleInfo;
    public final ExtConf extconf;

    MissionConfig(SMissionData missioninfo, Map<Integer, SSpecialScenarioQuestConfig> specailconfs) {
        if (missioninfo == null) {
            throw new RuntimeException("Element should not be null");
        }
        this.missionId = missioninfo.id;
        this.missionName = missioninfo.Name != null ? missioninfo.Name : "";
        this.missionTypeString = missioninfo.TypeStr != null ? missioninfo.TypeStr : "";
        this.limitInfo = new LimitInfo(missioninfo);
        this.rewardInfo = new RewardInfo(missioninfo);
        this.exeIndo = new ExeInfo(missioninfo);
        this.answerInfo = new AnswerInfo(missioninfo);
        this.aiInfo = new AIInfo(missioninfo);
        this.battleInfo = new BattleInfo(missioninfo);
        this.scenarioInfo = new ScenarioInfo(missioninfo);
        this.extconf = new ExtConf(this.missionId, specailconfs);
    }

    public void addShowing(final long roleid, final boolean isTeamLeader) {
        Procedure p = new Procedure(){

            protected boolean process() {
                ShowingMission st = Showingmission.get((Long)roleid);
                if (st == null) {
                    st = Pod.newShowingMission();
                    Showingmission.insert((Long)roleid, (ShowingMission)st);
                }
                st.setMissionid(MissionConfig.this.missionId);
                st.setIsleader(isTeamLeader);
                return true;
            }
        };
        if (Transaction.current() == null) {
            p.submit();
        } else {
            p.call();
        }
    }

    void afterGoto(long roleid) {
        if (this.hasAni() && UtilHelper.getAnimeType(this.scenarioInfo.animationID) == UtilHelper.AnimeType.ANIMATION) {
            CGPlayUtil.sendStartCGProtocal((long)roleid, (int)this.scenarioInfo.animationID);
        }
        this.removeShowing(roleid);
    }

    void afterNote(long roleid, boolean isTeamLeader) {
        if (this.hasGoto()) {
            this.jump(roleid, isTeamLeader);
        } else {
            this.afterGoto(roleid);
        }
    }

    public SSpecialScenarioQuestConfig getSpecialScenarioQuestConfig() {
        return this.extconf.sconf;
    }

    boolean hasAni() {
        return this.scenarioInfo.animationID != 0 && this.scenarioInfo.animationID != -1;
    }

    boolean hasCG() {
        return UtilHelper.getAnimeType(this.scenarioInfo.animationID) == UtilHelper.AnimeType.ANIMATION;
    }

    boolean hasGoto() {
        return this.rewardInfo.jtype != RewardInfo.JUMPTYPE.NULL;
    }

    boolean hasNote() {
        return this.rewardInfo.hasNote;
    }

    private void jump(long roleid, boolean isTeamLeader) {
        boolean hasCG = this.hasCG();
        if (hasCG) {
            this.addShowing(roleid, isTeamLeader);
        }
        if (!isTeamLeader) {
            return;
        }
        if (this.rewardInfo.jtype == RewardInfo.JUMPTYPE.DREAMLAND) {
            if (UtilHelper.isFairylandMap(this.rewardInfo.jumpmapID)) {
                FairylandMgr.getInstance().enterIntoDreamLand(roleid, this.rewardInfo.jumpmapID, this.rewardInfo.jumpXpos, this.rewardInfo.jumpYpos, hasCG, isTeamLeader);
            } else {
                FairylandMgr.getInstance().finishDreamLandTask(roleid, this.rewardInfo.jumpmapID, this.rewardInfo.jumpXpos, this.rewardInfo.jumpYpos, hasCG);
            }
            return;
        }
        if (!hasCG) {
            DynamicTemplate dt = SceneManager.getInstance().getDynamicTemplate(this.rewardInfo.jumpmapID);
            if (dt != null) {
                DuplicateHelper.enterDynamicSceneWhileCommit((long)roleid, (int)this.rewardInfo.jumpmapID, (int)this.rewardInfo.jumpXpos, (int)this.rewardInfo.jumpYpos, (long)roleid, (String)dt.getName(), (boolean)false, (int)0, (int)516022);
            } else {
                Transfer.justGotoWhileCommit((long)roleid, (long)this.rewardInfo.jumpmapID, (int)this.rewardInfo.jumpXpos, (int)this.rewardInfo.jumpYpos, (int)516018);
            }
            this.removeShowing(roleid);
        } else {
            DynamicTemplate dt = SceneManager.getInstance().getDynamicTemplate(this.rewardInfo.jumpmapID);
            if (dt != null) {
                DuplicateHelper.enterDynamicSceneWhileCommit((long)roleid, (int)this.rewardInfo.jumpmapID, (int)this.rewardInfo.jumpXpos, (int)this.rewardInfo.jumpYpos, (long)roleid, (String)dt.getName(), (boolean)false, (int)0, (int)516018);
            } else {
                Transfer.justGotoWhileCommit((long)roleid, (long)this.rewardInfo.jumpmapID, (int)this.rewardInfo.jumpXpos, (int)this.rewardInfo.jumpYpos, (int)516018);
            }
        }
    }

    private void removeShowing(final long roleid) {
        Procedure p = new Procedure(){

            protected boolean process() {
                ShowingMission showing = Showingmission.get((Long)roleid);
                if (showing != null && showing.getMissionid() == MissionConfig.this.missionId) {
                    Showingmission.remove((Long)roleid);
                }
                return true;
            }
        };
        if (Transaction.current() == null) {
            p.submit();
        } else {
            p.call();
        }
    }

    static class ScenarioMissionRewardItem {
        public int itemid;
        public int itemnum;
        public boolean isBind;
        public int needShape;

        ScenarioMissionRewardItem() {
        }

        ScenarioMissionRewardItem(int itemid, int itemnum, boolean isBind, int needShape) {
            this.itemid = itemid;
            this.itemnum = itemnum;
            this.isBind = isBind;
            this.needShape = needShape;
        }
    }

    public static class ScenarioInfo {
        public final int animationID;

        ScenarioInfo(SMissionData missioninfo) {
            this.animationID = missioninfo.AnimationID;
        }
    }

    static class RewardInfo {
        public final JUMPTYPE jtype;
        public final int jumpmapID;
        public final int jumpXpos;
        public final int jumpYpos;
        public final ArrayList<Integer> postMissionList = new ArrayList();
        public final ArrayList<Integer> displayNpcIDs = new ArrayList();
        public final long expReward;
        public final long moneyReward;
        public final long petExpReward;
        public final long sMoney;
        public final int rewardType;
        public final int rewardOption;
        public final Set<ScenarioMissionRewardItem> rewardItemList = new HashSet<ScenarioMissionRewardItem>();
        public final boolean hasNote;
        public final int lilianSW;

        public RewardInfo(SMissionData missioninfo) {
            if (missioninfo.DisplayNpc != null) {
                this.displayNpcIDs.addAll(missioninfo.DisplayNpc);
            }
            this.expReward = missioninfo.RewardExp;
            this.moneyReward = missioninfo.RewardMoney;
            this.petExpReward = missioninfo.RewardPetExp;
            this.rewardType = missioninfo.RewardType;
            this.rewardOption = missioninfo.RewardOption;
            if (missioninfo.NextMissionList != null) {
                this.postMissionList.addAll(missioninfo.NextMissionList);
            }
            if (missioninfo.RewardItemIDList != null) {
                for (int i = 0; i < missioninfo.RewardItemIDList.size(); ++i) {
                    boolean isBind = true;
                    if (missioninfo.RewardItemIsBindList != null && i < missioninfo.RewardItemIsBindList.size()) {
                        isBind = missioninfo.RewardItemIsBindList.get(i) == 1;
                    }
                    int needShape = 0;
                    if (missioninfo.RewardItemShapeIDList != null && i < missioninfo.RewardItemShapeIDList.size()) {
                        needShape = missioninfo.RewardItemShapeIDList.get(i);
                    }
                    this.rewardItemList.add(new ScenarioMissionRewardItem(missioninfo.RewardItemIDList.get(i), missioninfo.RewardItemNumList.get(i), isBind, needShape));
                }
            }
            this.sMoney = missioninfo.SMoney;
            switch (missioninfo.RewardMapJumpType) {
                case 0: {
                    this.jtype = JUMPTYPE.NULL;
                    break;
                }
                case 1: {
                    this.jtype = JUMPTYPE.GOTO;
                    break;
                }
                case 2: {
                    this.jtype = JUMPTYPE.FLY;
                    break;
                }
                case 3: {
                    this.jtype = JUMPTYPE.DREAMLAND;
                    break;
                }
                default: {
                    throw new IllegalArgumentException("错误的跳转地图参数");
                }
            }
            this.jumpmapID = missioninfo.RewardMapID;
            this.jumpXpos = missioninfo.RewardMapXPos;
            this.jumpYpos = missioninfo.RewardMapYPos;
            this.hasNote = missioninfo.FinishConversationList != null && !missioninfo.FinishConversationList.isEmpty();
            this.lilianSW = missioninfo.ShengWang;
        }

        public static enum JUMPTYPE {
            NULL,
            GOTO,
            FLY,
            DREAMLAND;

        }
    }

    static class MissionTaskInfo {
        MissionTaskInfo() {
        }
    }

    static class LimitInfo {
        public final Set<Integer> brotherMissions = new HashSet<Integer>();
        public final int minLevel;
        public final int maxLevel;
        public final int transMinLevel;
        public final int transMaxLevel;
        public final Set<Integer> requireMissionList = new HashSet<Integer>();
        public final Set<Long> requireRoleIDList = new HashSet<Long>();

        LimitInfo(SMissionData missioninfo) {
            this.maxLevel = missioninfo.LevelMax;
            this.minLevel = missioninfo.LevelMin;
            this.transMaxLevel = missioninfo.LevelMaxTrans;
            this.transMinLevel = missioninfo.LevelMinTrans;
            if (missioninfo.NeedMissionList != null) {
                this.requireMissionList.addAll(missioninfo.NeedMissionList);
            }
            if (missioninfo.NeedRoleIDList != null) {
                this.requireRoleIDList.addAll(missioninfo.NeedRoleIDList);
            }
        }
    }

    private static class ExtConf {
        private SSpecialScenarioQuestConfig sconf;

        ExtConf(int taskid, Map<Integer, SSpecialScenarioQuestConfig> specailconfs) {
            this.sconf = specailconfs.get(taskid);
        }
    }

    public static class ExeInfo {
        public final int missionType;
        public final int npcID;
        public final int mapID;
        public final int leftPos;
        public final int topPos;
        public final int rightPos;
        public final int bottomPos;
        public final int targetID;
        public final int targetNum;
        public final int miniStep;
        public final int stepProbability;
        public final int maxStep;
        public final int teamState;
        public final int timelimit;
        public final int transformID;
        public final int followID;
        public final int cruiseID;
        public final long giveBackMoney;
        public final int giveBackPetID;
        public final int useItemID;
        public final int hasOtherLimit;
        public final int share;
        public final ArrayList<Integer> ignoreMaps = new ArrayList();
        public final int unionSeekHelp;
        public final int worldSeekHelp;
        public final int helpBonus;

        public ExeInfo(SMissionData missioninfo) {
            this.missionType = missioninfo.Type;
            this.npcID = missioninfo.ExeNpcID;
            this.mapID = missioninfo.ExeMapID;
            this.leftPos = missioninfo.ExeLeftPos;
            this.topPos = missioninfo.ExeTopPos;
            this.rightPos = missioninfo.ExeRightPos;
            this.bottomPos = missioninfo.ExeBottomPos;
            this.targetID = missioninfo.ExeTargetID;
            this.targetNum = missioninfo.ExeTargetNum;
            this.miniStep = missioninfo.ExeMiniStep;
            this.stepProbability = missioninfo.ExeStepProbability;
            this.maxStep = missioninfo.ExeMaxStep;
            this.teamState = missioninfo.ExeTeamState;
            this.timelimit = missioninfo.ExeTimeLimit;
            this.giveBackMoney = missioninfo.ExeGiveBackMoney;
            this.giveBackPetID = missioninfo.ExeGiveBackPetID;
            this.useItemID = missioninfo.ExeUseItemID;
            this.transformID = missioninfo.TransformID;
            this.followID = missioninfo.FollowID;
            this.cruiseID = missioninfo.CruiseId;
            this.hasOtherLimit = missioninfo.ExeOtherType;
            this.share = missioninfo.share;
            if (missioninfo.BuShuaGuaiMaps != null) {
                this.ignoreMaps.addAll(missioninfo.BuShuaGuaiMaps);
            }
            this.unionSeekHelp = missioninfo.UnionSeekHelp;
            this.worldSeekHelp = missioninfo.WorldSeekHelp;
            this.helpBonus = missioninfo.HelpBonus;
        }
    }

    public static class BattleInfo {
        public final int battleMapID;
        public final int battleZoneID;
        public final int drop;
        public final int battleTimes;
        public final List<Integer> monsterList;
        public final int monsterNum;
        public final int dropItemID;
        public final int dropItemNum;
        public final int battleVideo;

        public BattleInfo(SMissionData missioninfo) {
            this.battleMapID = missioninfo.BattleMapType;
            this.battleZoneID = missioninfo.BattleZoneID;
            this.drop = missioninfo.BattleDrop;
            this.battleTimes = missioninfo.BattleTimes;
            this.monsterList = missioninfo.BattleMonsterList;
            this.monsterNum = missioninfo.BattleMonsterNum;
            this.dropItemID = missioninfo.BattleDropItemID;
            this.dropItemNum = missioninfo.BattleDropItemNum;
            this.battleVideo = missioninfo.BattleVideo;
        }
    }

    static class AnswerInfo {
        public final int MAX_ANSWERS = 6;
        public final int npcID;
        public final int correctAnswerID;
        public final String conversion;
        public final int answersNum;
        public final String[] answers = new String[6];

        public AnswerInfo(SMissionData missioninfo) {
            this.correctAnswerID = 0;
            this.npcID = missioninfo.AnswerNpcID;
            this.conversion = missioninfo.AnswerConversion;
            this.answers[this.correctAnswerID] = missioninfo.AnswerCorrect;
            if (missioninfo.AnswerWrongList != null) {
                int i;
                int j = 0;
                for (i = 0; i < 6 && j < missioninfo.AnswerWrongList.size(); ++i) {
                    if (i == this.correctAnswerID) continue;
                    this.answers[i] = missioninfo.AnswerWrongList.get(j);
                    ++j;
                }
                this.answersNum = i;
            } else {
                this.answersNum = 0;
            }
        }
    }

    public static class AIInfo {
        public final int aIID;
        public final int battleResult;
        public final int teamState;

        public AIInfo(SMissionData missioninfo) {
            this.aIID = missioninfo.BattleAIID;
            this.battleResult = missioninfo.BattleAIResult;
            this.teamState = missioninfo.BattleAITeamSteate;
        }
    }
}

